#
#  MerlinMP3Player E2
#  Release: 0.95
#  Coded by Dr.Best (c)2009
#  Support: www.dreambox-tools.info
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.ProgressBar import ProgressBar
from Components.FileList import FileList
from Components.Label import Label
from Components.Pixmap import Pixmap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.Button import Button
from Components.config import *
from Components.MenuList import MenuList
from enigma import ePicLoad
from enigma import eTimer
import random
import merlin_mp3
from enigma import ePoint
from Components.MenuList import MenuList
from enigma import eListboxPythonMultiContent, eListbox, gFont, \
	RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_VALIGN_CENTER, RT_HALIGN_CENTER
from enigma import getDesktop
import os
HDSkin = False
coverArtFileName = ""

# MerlinMusicPlayer
from enigma import eServiceReference, iPlayableService, iServiceInformation
from Components.ServiceEventTracker import ServiceEventTracker
from Screens.InfoBarGenerics import InfoBarSeek
from Components.ServicePosition import ServicePositionGauge

config.plugins.merlinmp3player = ConfigSubsection()
config.plugins.merlinmp3player.screensaver = ConfigSelection(default="0", choices = [("0", _("No screensaver")), ("6", _("After 1 minute")),("30", _("After 5 minutes")),("60", _("After 10 minutes")),("180", _("After 30 minutes")),("360", _("After 1 hour"))])
config.plugins.merlinmp3player.sorting = ConfigSelection(default="0", choices = [("0", _("Sort Filenames Ascending")), ("1", _("Sort Filenames Descending")),("2", _("Sort Filedates Ascending")),("3", _("Sort Filedates Descending"))])
config.plugins.merlinmp3player.covers = ConfigSelection(default="7", choices = [("7", _("ID3Tag, Folder, Google-Images")), ("1", _("ID3Tag")),("3", _("ID3Tag, Folder")),("2", _("Folder")),("8", _("No Covers"))])

config.plugins.merlinmp3player.startdir = ConfigSelection(default="0", choices = [("1",_("Yes")),("0",_("No"))])
config.plugins.merlinmp3player.startdirname = ConfigText(default = "", visible_width = 50, fixed_size = False)
config.plugins.merlinmp3player.hardwaredecoder = ConfigSelection(default="0", choices = [("1",_("Yes")),("0",_("No"))])

def MerlinMP3Config(session, **kwargs):
	session.open(MerlinMP3PlayerSetup)

def main(session,**kwargs):
	session.open(MerlinMP3PlayerFileList)

def startidream(session, **kwargs):
	session.open(iDream)

def Plugins(**kwargs):

	list = [PluginDescriptor(name="Merlin MP3 Player", description=_("Merlin MP3 Player"), where = [PluginDescriptor.WHERE_PLUGINMENU,
	        PluginDescriptor.WHERE_EXTENSIONSMENU], fnc=main)]
	list.append(PluginDescriptor(name="Merlin MP3 Player Setup", description=_("Merlin MP3 Player Setup"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc=MerlinMP3Config))
	list.append(PluginDescriptor(name="Merlin iDream", description=_("iDream"), where = [PluginDescriptor.WHERE_PLUGINMENU,PluginDescriptor.WHERE_EXTENSIONSMENU ], fnc=startidream))

	return list

class MerlinMP3PlayerStart(Screen):
	global HDSkin
	sz_w = getDesktop(0).size().width()
	if sz_w == 1280:
		# Ueberpruefung, ob das HD Skin Packet installiert wurde...
		if ( os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png") and os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png")):
			HDSkin = True
		else:
			HDSkin = False
	else:
		HDSkin = False

	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerStart" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="selection" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3PlayerStart" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="selection" position="149,84" size="417,414" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
		
	def __init__(self, session, args = 0):
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.list = [ (_("iDream"), 0), (_("Filebrowser"), 1) ]
		self["selection"] = MenuList(self.list)
		self["actions"] = ActionMap(["WizardActions"],
		{
			"back": self.close,
			"ok": self.ok,
			"up": self.movedownup,
			"down": self.movedownup,
			"right": self.movedownup,
			"left" : self.movedownup,
		}, -1)
		self.onShown.append(self.lcdupdate)
		self.onClose.append(self.__onClose)
		self.CurrentService = self.session.nav.getCurrentlyPlayingServiceReference()
		self.session.nav.stopService()
		merlin_mp3.ClearScreen() #stopService loescht bei mir nicht immer den Bildschirm...deswegen eigene Funktion dafuer...

	def __onClose(self):
		merlin_mp3.Stop()
		self.session.nav.playService(self.CurrentService)

	def ok(self):
		if (self["selection"].getCurrent()[1] == 1):
			self.session.open(MerlinMP3PlayerFileList)
		else:
			self.session.open(iDream)

	def movedownup(self):
		self["selection"].down() # nur 2 Eintraege --> muss man nicht unterscheiden
		self.lcdupdate()

	def lcdupdate(self):
		index = self["selection"].getSelectionIndex()
		text = self["selection"].list[index]
		self.summaries.setText(text[0],1)
		# voheriges
		index -= 1
		if index < 0:
			index = len(self["selection"].list) -1
		text = self["selection"].list[index]
		self.summaries.setText(text[0],3)
		# naechstes
		index = self["selection"].getSelectionIndex() + 1
		if index > (len(self["selection"].list) -1):		
			index = 0
		text = self["selection"].list[index]
		self.summaries.setText(text[0],4)

	def createSummary(self):
		return LCDScreen


class iDream(Screen):
	global HDSkin
	sz_w = getDesktop(0).size().width()
	if sz_w == 1280:
		# Ueberpruefung, ob das HD Skin Packet installiert wurde...
		if ( os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png") and os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png")):
			HDSkin = True
		else:
			HDSkin = False
	else:
		HDSkin = False
	if HDSkin:
		skin = """
			<screen name="iDream" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Caption" position="138,85" zPosition="1" size="417,30" font="Regular;21" valign="left" transparent="1" foregroundColor="#047BBC" />
				<widget name="listbox" position="138,125" size="1021,557" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDream" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Caption" position="149,84" zPosition="1" size="417,30" font="Regular;18" valign="left" transparent="1" foregroundColor="#047BBC" />
				<widget name="listbox" position="149,124" size="417,374" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
		
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["Caption"] = Label("iDream")
		self.level = 0
		self.id = 0
		self.moveIndex = 0
		self["listbox"] = iDreamList([])
		self.onLayoutFinish.append(self.startRun)
		self.onShown.append(self.lcdupdate)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"ok": self.ok,
			"back": self.close,
			"info": self.showplaying,
			"input_date_time": self.database_maintenance,
			"up": self.moveup,
			"down": self.movedown,
			"right": self.moveright,
			"left" : self.moveleft,
		}, -1)
		merlin_mp3.iDreamCaptionChanged().append(self.CaptionChanged)
		self.onClose.append(self.__onClose)
		self.CurrentService = self.session.nav.getCurrentlyPlayingServiceReference()
		self.session.nav.stopService()
		merlin_mp3.ClearScreen() #stopService loescht bei mir nicht immer den Bildschirm...deswegen eigene Funktion dafuer...

	def startRun(self):
		self.updateList()

	def moveright(self):
		self["listbox"].pageDown()
		self.lcdupdate()

	def moveleft(self):
		self["listbox"].pageUp()
		self.lcdupdate()
		
	def moveup(self):
		self["listbox"].up()
		self.lcdupdate()

	def movedown(self):
		self["listbox"].down()
		self.lcdupdate()

	def lcdupdate(self):
		index = self["listbox"].getSelectionIndex()
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][0],1)
		# voheriges
		index -= 1
		if index < 0:
			index = len(self["listbox"].list) -1
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][0],3)
		# naechstes
		index = self["listbox"].getSelectionIndex() + 1
		if index > (len(self["listbox"].list) -1):		
			index = 0
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][0],4)

	def CaptionChanged(self, msg):
		self["Caption"].setText(msg);

	def showplaying(self):
		if (merlin_mp3.isPlaying() == 1):
			self.session.open(MerlinMP3Player,"","", 0, 0, 0)

	def updateList(self):
		self["listbox"].buildList(merlin_mp3.GetiDreamList(self["listbox"].getCurrentIndex(), self.moveIndex, self.level, self.id))

	def ok(self):
		# die ganze Logik und Implementierung fuer iDream ist im C++ Code...Python zeigt nur an...
		self.level = self["listbox"].l.getCurrentSelection()[0][1] # ebene
		self.id = self["listbox"].l.getCurrentSelection()[0][2] # id
		self.moveIndex = self["listbox"].l.getCurrentSelection()[0][6] # [back] oder normales ListItem
		if (self["listbox"].l.getCurrentSelection()[0][4] == 0): #wenn kein abspielbares ListItem...
			self.updateList();
			if (self.moveIndex != -1): # bei [back] an die alte Stelle springen...
				self["listbox"].moveSelectionTo(self.moveIndex)
			self.lcdupdate()
		else: # ...ansonsten Player starten
			merlin_mp3.Stop()
			self.session.nav.stopService()
			global coverArtFileName
			coverArtFileName = ""
			self.session.open(MerlinMP3Player,"", "", self.level, self.id, self["listbox"].l.getCurrentSelection()[0][5])

	def database_maintenance(self):
		if (self.level == 0): # nur vom Hauptmenu aus...
			self.session.openWithCallback(self.MaintenanceFinished, iDreamDatabaseMaintenance)
	
	def MaintenanceFinished(self, val):
		if val:
			self.id = 0
			self.moveIndex = 0
			self.updateList()
			self.lcdupdate()

	def createSummary(self):
		return LCDScreen

	def __onClose(self):
		merlin_mp3.iDreamCaptionChanged().remove(self.CaptionChanged)
		merlin_mp3.Stop()
		self.session.nav.playService(self.CurrentService)

class iDreamDatabaseMaintenance(Screen):

	if HDSkin:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="149,84" size="417,414" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self.list = []
		self.list = [ (_("Delete iDream database"), 0), (_("Update iDream database"), 1) ]
		self["listbox"] = MenuList(self.list)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"back": self.CloseDatabaseMaintenance,
			"ok": self.ok,
		}, -1)

	def ok(self):
		if (self["listbox"].getCurrent()[1] == 0):
			self.session.openWithCallback(self.deletedatabase, MessageBox, "Do you really want to delete the iDream database?")
		else:
			self.session.open(MessageBox, "This function is not implemented yet...", type = MessageBox.TYPE_INFO, timeout = 3) 

	def deletedatabase(self,val):
		if val:
			os.remove("/hdd/merlinmp3player.db")
			self.session.open(MessageBox, "iDream database deleted", type = MessageBox.TYPE_INFO, timeout = 3) 
			self.close(1)
	def CloseDatabaseMaintenance(self):
		self.close(0)

class iDreamAddItemDisplay(Screen):

	if HDSkin:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Display" position="138,85" zPosition="1" size="1021,597" font="Regular;18" halign="center" valign="center" transparent="1" foregroundColor="#047BBC" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="iDreamAddItemDisplay" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="Display" position="149,84" zPosition="1" size="417,414" font="Regular;18" halign="center" valign="center" transparent="1" foregroundColor="#047BBC" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session, directory):
		self.session = session
		Screen.__init__(self, session)
		self.directory = directory
		self["Display"] = Label("Press OK to start.\n\nPress Exit to leave.")
		self.canClose = True
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions"],
		{
			"back": self.closeWindow,
			"ok": self.ok,
		}, -1)
		merlin_mp3.iDreamItemAdded().append(self.ItemAdded)
		merlin_mp3.FillPlayListFromDirectoryFinished().append(self.Finished)
		self.onClose.append(self.__onClose)


	def closeWindow(self):
		if self.canClose:
			self.close(0)

	def ok(self):
		self.canClose = False
		merlin_mp3.FillDatabaseFromDirectory(self.directory ,0)

	def ItemAdded(self, msg):
		self["Display"].setText(msg)
	
	def Finished(self, counter):
		text = ("Finished...\n%d songs added to database!\n\nPress Exit to close" % counter)
		self["Display"].setText(text)
		self.canClose = True
	
	def __onClose(self):
		merlin_mp3.iDreamItemAdded().remove(self.ItemAdded)
		merlin_mp3.FillPlayListFromDirectoryFinished().remove(self.Finished)

class MerlinMP3PlayerFileList(Screen):
	global HDSkin
	sz_w = getDesktop(0).size().width()
	if sz_w == 1280:
		# Ueberpruefung, ob das HD Skin Packet installiert wurde...
		if ( os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png") and os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png")):
			HDSkin = True
		else:
			HDSkin = False
	else:
		HDSkin = False
	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerFileList" position="0,0" size="1280,720" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<widget name="filelist" position="138,85" size="1021,597" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3PlayerFileList" position="0,0" size="720,576" title="MerlinMP3Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion2-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<widget name="filelist" position="40,82" size="647,452" scrollbarMode="showOnDemand" zPosition="1" transparent="0"  backgroundColor="#00000000" />
			</screen>"""
		
	def __init__(self, session, args = 0):
		self.session = session
		Screen.__init__(self, session)
		if int(config.plugins.merlinmp3player.hardwaredecoder.value) == 0:
			mp = "(?i)^.*\.(mp3|m3u)"
		else:
			mp = "(?i)^.*\.(mp3|m3u|ogg|m4a|flac)"

		if int(config.plugins.merlinmp3player.startdir.value) == 1 and str(config.plugins.merlinmp3player.startdirname.value) != "":
			startd = config.plugins.merlinmp3player.startdirname.value
		else:
			startd = None

		self["filelist"] = FileList(startd, showDirectories = True, showFiles = True, matchingPattern = mp, useServiceRef = False)


		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "merlinActions"],
		{
			"back": self.close,
			"ok": self.ok,
			"pause": self.ok, # 8k
			"info": self.showplaying,
			"green": self.playdirectory,
			"red": self.filldatabase,
			"input_date_time": self.setstartdir,
			"up": self.moveup,
			"down": self.movedown,
			"right": self.moveright,
			"left" : self.moveleft,
		}, -1)
		self.onShown.append(self.lcdupdate)
		self.onClose.append(self.__onClose)
		self.CurrentService = self.session.nav.getCurrentlyPlayingServiceReference()
		self.session.nav.stopService()
		merlin_mp3.ClearScreen() #stopService loescht bei mir nicht immer den Bildschirm...deswegen eigene Funktion dafuer...

	def __onClose(self):
		merlin_mp3.Stop()
		self.session.nav.playService(self.CurrentService)


	def setstartdir(self):
		self.session.openWithCallback(self.SetStartDirConfirm,  MessageBox, _("Set current directory as start-dir?"))


	def SetStartDirConfirm(self, answer):
		if answer:
			config.plugins.merlinmp3player.startdir.value = "1"
			config.plugins.merlinmp3player.startdir.save()
			try:
				config.plugins.merlinmp3player.startdirname.value = self["filelist"].getCurrentDirectory()
				config.plugins.merlinmp3player.startdirname.save()
				configfile.save()
			except: 
				config.plugins.merlinmp3player.startdir.cancel()
				config.plugins.merlinmp3player.startdirname.cancel()
				self.session.open(MessageBox, _("An Error occurs! You have to be in a valid directory!"), type = MessageBox.TYPE_INFO)

	def moveright(self):
		self["filelist"].pageDown()
		self.lcdupdate()

	def moveleft(self):
		self["filelist"].pageUp()
		self.lcdupdate()
		
	def moveup(self):
		self["filelist"].up()
		self.lcdupdate()

	def movedown(self):
		self["filelist"].down()
		self.lcdupdate()

	def lcdupdate(self):
		index = self["filelist"].getSelectionIndex()
		sel = self["filelist"].list[index]
		text = sel[1][7]
		if sel[0][1] == True:
			text = "/" + text
		self.summaries.setText(text,1)
		# voheriges
		index -= 1
		if index < 0:
			index = len(self["filelist"].list) -1
		sel = self["filelist"].list[index]
		text = sel[1][7]
		if sel[0][1] == True:
			text = "/" + text
		self.summaries.setText(text,3)
		# naechstes
		index = self["filelist"].getSelectionIndex() + 1
		if index > (len(self["filelist"].list) -1):		
			index = 0
		sel = self["filelist"].list[index]
		text = sel[1][7]
		if sel[0][1] == True:
			text = "/" + text
		self.summaries.setText(text,4)

	def filldatabase(self):
		self.session.open(iDreamAddItemDisplay,self["filelist"].getCurrentDirectory())

	def playdirectory(self):
		global coverArtFileName
		coverArtFileName = ""
		self.session.nav.stopService()
		merlin_mp3.Stop()
		if int(config.plugins.merlinmp3player.hardwaredecoder.value) == 0:
			self.session.open(MerlinMP3Player,self["filelist"].getCurrentDirectory(), "", 0, 0,0)
		else:
			self.session.open(MerlinMusicPlayer,self["filelist"].getCurrentDirectory(), "", 0, 0,0)
	
	def showplaying(self):
		if (merlin_mp3.isPlaying() == 1):
			if int(config.plugins.merlinmp3player.hardwaredecoder.value) == 0:
				self.session.open(MerlinMP3Player,"","", 0, 0,0)
		
	def startmp3player(self):
		global coverArtFileName
		coverArtFileName = ""
		merlin_mp3.Stop()
		self.session.nav.stopService()
		if int(config.plugins.merlinmp3player.hardwaredecoder.value) == 0:
			self.session.open(MerlinMP3Player,self["filelist"].getCurrentDirectory(), self["filelist"].getFilename(), 0, 0, 0)
		else:
			self.session.open(MerlinMusicPlayer,self["filelist"].getCurrentDirectory(), self["filelist"].getFilename(), 0, 0, 0)


	def ok(self):
		if self["filelist"].canDescent():
			self["filelist"].descent()
			self.lcdupdate()
		else:
			self.startmp3player()

#	def configmenu(self):
#		self.session.open(MerlinMP3PlayerSetup)

	def createSummary(self):
		return LCDScreen
		

class MerlinMP3PlayerSetup(Screen, ConfigListScreen):
	global HDSkin
	sz_w = getDesktop(0).size().width()
	if sz_w == 1280:
		# Ueberpruefung, ob das HD Skin Packet installiert wurde...
		if ( os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png") and os.path.isfile("/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png")):
			HDSkin = True
		else:
			HDSkin = False
	else:
		HDSkin = False
	if HDSkin:
		skin = """
			<screen name="MerlinMP3PlayerSetup" position="0,0" size="1280,720" flags="wfNoBorder" title="Merlin MP3 Player Setup" backgroundColor="#003366">
				<widget name="config" position="138,85" size="1021,597" zPosition="1" transparent="0" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/red.png" position="460,466" size="12,12" alphatest="on" zPosition="1"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/green.png" position="634,466" size="12,12" alphatest="on" zPosition="1"/>
				<widget name="key_red" position="474,452" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
				<widget name="key_green" position="648,452" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
			</screen>"""

	else:
		skin = """
			<screen name="MerlinMP3PlayerSetup" position="0,0" size="720,576" title="Merlin MP3 Player Setup" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="config"  position="40,82" size="647,452" zPosition="1" transparent="0" backgroundColor="#00000000" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion2-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/red.png" position="194,394" size="12,12" alphatest="on" zPosition="1"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/green.png" position="368,394" size="12,12" alphatest="on" zPosition="1"/>
				<widget name="key_red" position="208,380" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
				<widget name="key_green" position="382,380" zPosition="2" size="140,40" valign="center" halign="left" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />
			</screen>"""

	
	def __init__(self, session):
		Screen.__init__(self, session)

		self["key_red"] = Button(_("Cancel"))
		self["key_green"] = Button(_("OK"))
		
		self["actions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"green": self.save,
			"red": self.close,
			"cancel": self.close
		}, -2)
		
		MerlinMP3PlayerConfigList = []
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Screensaver:"), config.plugins.merlinmp3player.screensaver))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Art Cover:"), config.plugins.merlinmp3player.covers))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Sort Modus:"), config.plugins.merlinmp3player.sorting))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Use Start-directory:"), config.plugins.merlinmp3player.startdir))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Start-Directory:"), config.plugins.merlinmp3player.startdirname))
		MerlinMP3PlayerConfigList.append(getConfigListEntry(_("Use hardware-decoder to play (supported: MP3, OGG, M4A):"), config.plugins.merlinmp3player.hardwaredecoder))
		ConfigListScreen.__init__(self, MerlinMP3PlayerConfigList, session)
		
	def save(self):
		ConfigListScreen.keySave(self)
		configfile.save()

class MerlinMP3Player(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="MerlinMP3Player" position="0,0" size="1280,720" title="Merlin MP3 Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="300,204" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="154,490" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="152,536" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="150,578" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="148,623" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="1117,651" size="36,29" alphatest="on"/>
				<widget name="Current" position="858,317" zPosition="1" size="88,25" font="Regular;21" halign="right" transparent="1" foregroundColor="#B7B7B7" />
				<widget name="Remain" position="949,321" zPosition="1" size="70,20" font="Regular;16" halign="right" transparent="1" foregroundColor="#999999" />
				<widget name="Title" position="200,495" zPosition="1" size="1028,30" font="Regular;26" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="200,542" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="200,587" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="200,631" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="1151,655" zPosition="2" size="85,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="153,677" zPosition="2" size="1083,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="820,293" zPosition="1" size="198,14" transparent="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png" />
				<widget name="coverArt" zPosition="2" position="167,90" size="399,361" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/shuffle-fs8.png" zPosition="2" position="631,292" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/repeat-fs8.png" zPosition="2" position="629,261" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/play-fs8.png" zPosition="2" position="906,256" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/pause-fs8.png" zPosition="2" position="908,256" size="29,28" transparent="1" alphatest="blend"/>
				<widget name="nextArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/next-fs8.png" zPosition="2" position="904,257" size="36,24" transparent="1" alphatest="blend"/>
				<widget name="previousArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/previous-fs8.png" zPosition="2" position="904,257" size="36,26" transparent="1" alphatest="blend"/>
				<widget name="rewindArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/rewind-fs8.png" zPosition="2" position="868,258" size="33,22" transparent="1" alphatest="blend"/>
				<widget name="forwardArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/forward-fs8.png" zPosition="2" position="938,258" size="32,23" transparent="1" alphatest="blend"/>
				<widget name="2xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/2x-fs8.png" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="4xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/4x-fs8.png" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="8xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/8x-fs8.png" zPosition="2" position="901,258" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="16xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/16x-fs8.png" zPosition="2" position="901,258" size="37,21" transparent="1" alphatest="blend"/>
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMP3Player" position="0,0" size="720,576" title="Merlin MP3 Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/720_576-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="156,130" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="94,357" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="90,403" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="87,443" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="88,483" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="589,514" size="36,29" alphatest="on"/>
				<widget name="Current" position="510,218" zPosition="1" size="68,20" font="Regular;16" halign="right" transparent="1" foregroundColor="#B7B7B7" />
				<widget name="Remain" position="581,220" zPosition="1" size="54,16" font="Regular;12" halign="right" transparent="1" foregroundColor="#999999" />
				<widget name="Title" position="134,363" zPosition="1" size="439,28" font="Regular;24" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="134,410" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="134,450" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="134,490" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="622,519" zPosition="2" size="65,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="77,542" zPosition="2" size="610,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="436,197" zPosition="1" size="198,14" transparent="1" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png" />
				<widget name="coverArt" zPosition="2" position="100,77" size="238,238" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/shuffle-fs8.png" zPosition="2" position="370,203" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/repeat-fs8.png" zPosition="2" position="370,167" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/play-fs8.png" zPosition="2" position="524,162" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/pause-fs8.png" zPosition="2" position="526,162" size="29,28" transparent="1" alphatest="blend"/>
				<widget name="nextArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/next-fs8.png" zPosition="2" position="522,163" size="36,24" transparent="1" alphatest="blend"/>
				<widget name="previousArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/previous-fs8.png" zPosition="2" position="522,163" size="36,26" transparent="1" alphatest="blend"/>
				<widget name="rewindArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/rewind-fs8.png" zPosition="2" position="486,164" size="33,22" transparent="1" alphatest="blend"/>
				<widget name="forwardArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/forward-fs8.png" zPosition="2" position="556,164" size="32,23" transparent="1" alphatest="blend"/>
				<widget name="2xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/2x-fs8.png" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="4xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/4x-fs8.png" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="8xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/8x-fs8.png" zPosition="2" position="519,165" size="37,22" transparent="1" alphatest="blend"/>
				<widget name="16xArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/16x-fs8.png" zPosition="2" position="519,165" size="37,21" transparent="1" alphatest="blend"/>
			</screen>"""
		
	def __init__(self, session, directory, filename, level, id, subtable_id):
		self.session = session
		Screen.__init__(self, session)
		self["Current"] = Label()
		self["Remain"] = Label()
		self["Title"] = Label()
		self["Album"] = Label()
		self["Artist"] = Label()
		self["Genre"] = Label()
		self["shuffleArt"] =MerlinMP3PlayerIcons()
		self["repeatArt"] = MerlinMP3PlayerIcons()
		self["playArt"] = MerlinMP3PlayerIcons()
		self["pauseArt"] = MerlinMP3PlayerIcons()
		self["nextArt"] = MerlinMP3PlayerIcons()
		self["previousArt"] = MerlinMP3PlayerIcons()
		self["rewindArt"] = MerlinMP3PlayerIcons()
		self["forwardArt"] = MerlinMP3PlayerIcons()
		self["2xArt"] = MerlinMP3PlayerIcons()
		self["4xArt"] = MerlinMP3PlayerIcons()
		self["8xArt"] = MerlinMP3PlayerIcons()
		self["16xArt"] = MerlinMP3PlayerIcons()
		self["NextTitleCaption"] = Label(_("Next Song"))
		self["NextTitle"] = Label()
		self["Progressbar"] = ProgressBar()
		self["coverArt"] = MerlinMP3PlayerPixmap()
		self.ScreenSaverTimer = eTimer()
		self.ScreenSaverTimer.timeout.get().append(self.ScreenSaverTimer_Timeout)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "MediaPlayerActions", "merlinActions"],
		{
			"back": self.close,
			"stop": self.stopplaying,
			"yellow": self.pause,
			"blue": self.fastforward,
			"red": self.fastbackward,
			"green": self.play,
			"right": self.next,
			"left": self.previous,
			"prevBouquet": self.shufflelist,
			"nextBouquet": self.repeattitle,
			"info": self.getLyrics,
			"up": self.getcurrentplaylist,
			"down": self.getcurrentplaylist,
			"pause": self.pause, # 8k,
			"previous8k": self.fastbackward,
			"next8k": self.fastforward,

		}, -1)
		merlin_mp3.RemainChanged().append(self.RemainChanged)
		merlin_mp3.CurrentChanged().append(self.CurrentChanged)
		merlin_mp3.PercentChanged().append(self.PercentChanged)
		merlin_mp3.TitleChanged().append(self.TitleChanged)
		merlin_mp3.ArtistChanged().append(self.ArtistChanged)
		merlin_mp3.AlbumChanged().append(self.AlbumChanged)
		merlin_mp3.GenreChanged().append(self.GenreChanged)
		merlin_mp3.YearChanged().append(self.YearChanged)
		merlin_mp3.CoverChanged().append(self.CoverChanged)
		merlin_mp3.LyricsChanged().append(self.LyricsChanged)
		merlin_mp3.RepeatTitleChanged().append(self.RepeatTitleChanged)
		merlin_mp3.Finished().append(self.Finished)
		merlin_mp3.NextTitleChanged().append(self.NextTitleChanged)
		merlin_mp3.ShuffleStateChanged().append(self.ShuffleStateChanged)
		merlin_mp3.StatusChanged().append(self.StatusChanged)
		self.directory = directory
		self.filename = filename
		self.level = level
		self.id = id
		self.subtable_id = subtable_id
		self.shuffle = 0
		self.repeat_title = 0
		self.lyrics = ""
		self.currentcover = ""
		self.init = 0
		self.screensaverconfig = int(config.plugins.merlinmp3player.screensaver.value)
		self.coverconfig = int(config.plugins.merlinmp3player.covers.value)
		self.sortingconfig = int(config.plugins.merlinmp3player.sorting.value)
		self.onClose.append(self.__onClose)
		self.onShown.append(self.IconInit)
		self.onLayoutFinish.append(self.startRun)
		self.nexttile = ""
		
	def IconInit(self):
		if (self.init == 0):
			self["nextArt"].hide()
			self["previousArt"].hide()
			self["rewindArt"].hide()
			self["forwardArt"].hide()
			self["2xArt"].hide()
			self["4xArt"].hide()
			self["8xArt"].hide()
			self["16xArt"].hide()
			self["playArt"].hide()
			self["shuffleArt"].hide()
			self["repeatArt"].hide()
			self["pauseArt"].hide()
			if coverArtFileName != "":
				self["coverArt"].updateCoverArt(coverArtFileName)
			self.startmp3()
			self.init = 1
	
	def startRun(self):
		if coverArtFileName != "":
			self["coverArt"].onShow()
		self["coverArt"].hide()
		self["Progressbar"].setValue(0)

	def stopplaying(self):
		merlin_mp3.Stop()
		self.close(0)

#	def showConfig(self):
#		if self.ScreenSaverTimer.isActive():
#			self.ScreenSaverTimer.stop()
#		self.session.openWithCallback(self.showConfigDone, MerlinMP3PlayerSetup)
#
#	def showConfigDone(self):
#		self.screensaverconfig = int(config.plugins.merlinmp3player.screensaver.value)
#		self.coverconfig = int(config.plugins.merlinmp3player.covers.value)
#		self.sortingconfig = int(config.plugins.merlinmp3player.sorting.value)
#		merlin_mp3.SetCoverConfig(self.coverconfig)
#		self.ResetScreenSaverTimer()

	def shufflelist(self):
		merlin_mp3.ShuffleList()
		self.ResetScreenSaverTimer()
		
	def ShuffleStateChanged(self,msg):
		if (msg != 1):
		    self["shuffleArt"].hide()
		else:
		    self["shuffleArt"].show()

	def ScreenSaverTimer_Timeout(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		_text = self["Title"].getText()
		text = ""
		if len(_text) != 0:
			text = _text + " - "
		text = text + self["Artist"].getText()
		self.session.openWithCallback(self.ResetScreenSaverTimer, ScreenSaver, self.currentcover, text, _text , self.nexttile )
		
	def ResetScreenSaverTimer(self):
		if self.screensaverconfig != 0:
			if self.ScreenSaverTimer.isActive():
				self.ScreenSaverTimer.stop()
			self.ScreenSaverTimer.start(self.screensaverconfig * 10000)

	def CoverChanged(self,filename):
		global coverArtFileName
		self.currentcover = filename
		if len(filename) != 0:
			self["coverArt"].updateCoverArt(filename)
			coverArtFileName = filename
		else:
			self["coverArt"].hide()
			coverArtFileName = ""

	def ArtistChanged(self,msg):
		self["Artist"].setText(msg)
		
	def AlbumChanged(self,msg):
		self["Album"].setText(msg)
		
	def GenreChanged(self,msg):
		self["Genre"].setText(msg)

	def YearChanged(self, msg):
		if (len(msg) != 0):
			text = self["Album"].getText()
			text = text + " (" + msg + ")"
			self["Album"].setText(text)
		
	def getLyrics(self):
		merlin_mp3.GetLyrics();
		self.ResetScreenSaverTimer()
		
	def LyricsChanged(self, msg):
		self.ResetScreenSaverTimer()
		self.lyrics = msg
		_text = self["Title"].getText()
		self.session.open(LyricsView,msg, _text)
		
	def CurrentChanged(self, msg):
		self["Current"].setText(msg)
		self.summaries.setText(msg,3)
		
	def RemainChanged(self, msg):
		self["Remain"].setText(msg)
		
	def PercentChanged(self, msg):
		self["Progressbar"].setValue(msg)
		
	def TitleChanged(self,msg):
		self["Title"].setText(msg)
		self.summaries.setText(msg,1)
		
	def startmp3(self):
		if (self.directory != "" ):
			merlin_mp3.Start(self.directory, self.filename,self.coverconfig, self.sortingconfig,1)
		else:
			if (self.level == 0 and self.id == 0):
				merlin_mp3.getInfos()
			else:
				merlin_mp3.Start_iDreamPlaylist(self.level, self.id, self.subtable_id, self.coverconfig)
		self.ResetScreenSaverTimer()

	def getcurrentplaylist(self):
		self.session.open(CurrentPlaylist)
		self.ResetScreenSaverTimer()

	def play(self):
		back = merlin_mp3.Play()
		self.ResetScreenSaverTimer()
		
	def pause(self):
		merlin_mp3.Pause()
		self.ResetScreenSaverTimer()
		
	def fastforward(self):
		merlin_mp3.FastForward()
		self.ResetScreenSaverTimer()
		
	def fastbackward(self):
		merlin_mp3.FastBackward()
		self.ResetScreenSaverTimer()
		
	def next(self):
		merlin_mp3.Next()
		self.ResetScreenSaverTimer()
		
	def previous(self):
		merlin_mp3.Previous()
		self.ResetScreenSaverTimer()
		
	def NextTitleChanged(self,title, artist):
		if (len(artist) != 0):	
			text = title + " - " + artist
		else:
			text = title
		self["NextTitle"].setText(text)
		self.nexttile = text
		self.summaries.setText(text,4)
		
	def Finished(self, result):
		if (result == 1):
			self.close()
		
	def repeattitle(self):
		merlin_mp3.RepeatTitle()
		self.ResetScreenSaverTimer()
		
	def RepeatTitleChanged(self,msg):
		if (msg != 1):
		    self["repeatArt"].hide()
		else:
		    self["repeatArt"].show()
	
	def StatusChanged(self, status):
		if (not (status & 1)):
		    self["playArt"].hide()
		if (not (status & 2)):
		    self["pauseArt"].hide()
		if (not (status & 16)):
		    self["nextArt"].hide()
		if (not (status & 32)):
		    self["previousArt"].hide()
		if ( not (status & 4)):
		    self["forwardArt"].hide()
		if (not (status & 8)):
		    self["rewindArt"].hide()
		if (not (status & 1024)):
				self["2xArt"].hide()
		if (not (status & 2048)):
				self["4xArt"].hide()
		if (not (status & 4096)):
				self["8xArt"].hide()
		if (not (status & 8192)):
				self["16xArt"].hide()
		if (status & 1):
		    self["playArt"].show()
		elif (status & 2):
		    self["pauseArt"].show()
		elif (status & 16):
		    self["nextArt"].show()
		elif (status & 32):
		    self["previousArt"].show()
		elif (status & 4):
		    self["forwardArt"].show()
		elif (status & 8):
		    self["rewindArt"].show()
		if ((status & 4) or (status & 8)):
			if (status & 1024):
				self["2xArt"].show()
			if (status & 2048):
				self["4xArt"].show()
			if (status & 4096):
				self["8xArt"].show()
			if (status & 8192):
				self["16xArt"].show()

	def createSummary(self):
		return LCDPlayerScreen

	def __onClose(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		merlin_mp3.RemainChanged().remove(self.RemainChanged)
		merlin_mp3.CurrentChanged().remove(self.CurrentChanged)
		merlin_mp3.PercentChanged().remove(self.PercentChanged)
		merlin_mp3.TitleChanged().remove(self.TitleChanged)
		merlin_mp3.ArtistChanged().remove(self.ArtistChanged)
		merlin_mp3.AlbumChanged().remove(self.AlbumChanged)
		merlin_mp3.GenreChanged().remove(self.GenreChanged)
		merlin_mp3.YearChanged().remove(self.YearChanged)
		merlin_mp3.CoverChanged().remove(self.CoverChanged)
		merlin_mp3.LyricsChanged().remove(self.LyricsChanged)
		merlin_mp3.NextTitleChanged().remove(self.NextTitleChanged)
		merlin_mp3.RepeatTitleChanged().remove(self.RepeatTitleChanged)
		merlin_mp3.ShuffleStateChanged().remove(self.ShuffleStateChanged)
		merlin_mp3.StatusChanged().remove(self.StatusChanged)
		merlin_mp3.Finished().remove(self.Finished)

class MerlinMP3PlayerPixmap(Pixmap):

	def __init__(self):
		Pixmap.__init__(self)
		self.coverArtFileName = ""
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintCoverArtPixmapCB)

	def onShow(self):
		Pixmap.onShow(self)
		self.picload.setPara((self.instance.size().width(), self.instance.size().height(), 1, 1, False, 1, "#00000000"))

	def paintCoverArtPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self.instance.setPixmap(ptr.__deref__())
			self.instance.show()

	def updateCoverArt(self, filename):
		new_coverArtFileName = filename
		if (self.coverArtFileName != new_coverArtFileName) or ( new_coverArtFileName == "/tmp/.id3cover") or ( new_coverArtFileName == "/tmp/.id3coverart"):
			self.coverArtFileName = new_coverArtFileName
			self.picload.startDecode(self.coverArtFileName)
		else:
			self.instance.show()

class MerlinMP3PlayerIcons(Pixmap):

	def __init__(self):
		Pixmap.__init__(self)
		self.IconFileName = ""
		self.picload = ePicLoad()
		self.picload.PictureData.get().append(self.paintIconPixmapCB)

	def onShow(self):
		Pixmap.onShow(self)
		self.picload.setPara((self.instance.size().width(), self.instance.size().height(), 1, 1, False, 1, "#00000000"))

	def paintIconPixmapCB(self, picInfo=None):
		ptr = self.picload.getData()
		if ptr != None:
			self.instance.setPixmap(ptr.__deref__())

	def updateIcon(self, filename):
		new_IconFileName = filename
		if (self.IconFileName != new_IconFileName):
			self.IconFileName = new_IconFileName
			self.picload.startDecode(self.IconFileName)

class CurrentPlaylist(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="CurrentPlaylist" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="138,85" size="1021,597" zPosition="1" transparent="0"  backgroundColor="#00000000" foregroundColor="#B7B7B7" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="CurrentPlaylist" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="listbox" position="40,82" size="647,452" zPosition="1" transparent="0"  backgroundColor="#00000000" foregroundColor="#B7B7B7" scrollbarMode="showOnDemand" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion2-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""
	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self["listbox"] = CurrentPlayList([])
		self.onLayoutFinish.append(self.startRun)
		self.onShown.append(self.lcdupdate)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "merlinActions"],
		{
			"ok": self.ok,
			"back": self.back,
			"pause": self.ok, # 8k
			"green": self.ok,
			"up": self.moveup,
			"down": self.movedown,
			"right": self.moveright,
			"left" : self.moveleft,
			
		}, -1)
		self.list = list

	def startRun(self):
		
		self["listbox"].buildList(merlin_mp3.GetCurrentPlayList())

	def moveright(self):
		self["listbox"].pageDown()
		self.lcdupdate()

	def moveleft(self):
		self["listbox"].pageUp()
		self.lcdupdate()
		
	def moveup(self):
		self["listbox"].up()
		self.lcdupdate()

	def movedown(self):
		self["listbox"].down()
		self.lcdupdate()

	def lcdupdate(self):
		index = self["listbox"].getSelectionIndex()
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][1],1)
		# voheriges
		index -= 1
		if index < 0:
			index = len(self["listbox"].list) -1
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][1],3)
		# naechstes
		index = self["listbox"].getSelectionIndex() + 1
		if index > (len(self["listbox"].list) -1):		
			index = 0
		text = self["listbox"].list[index]
		self.summaries.setText(text[0][1],4)

	def ok(self):
		sel = self["listbox"].l.getCurrentSelection()[0][0]
		if sel is None:
			return
		print "!---------------->sel = %s"%sel
		self.close(merlin_mp3.PlaySelectedItem(sel)) # entweder direktes abspielen mit gstreamer (merlinmp3player) oder rueckgabe des files (fuer musicplayer)
	def back(self):
		self.close("")


	def createSummary(self):
		return LCDScreen


class LyricsView(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="LyricsView" position="0,0" size="1280,720" flags="wfNoBorder" title="Merlin MP3 Player Lyrics" backgroundColor="#00000000">
				<widget name="lyric_text" position="138,85" size="1021,597" font="Regular;30" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/HDSelektion-fs8.png" position="0,0" size="1280,720" alphatest="on" zPosition="0"/>
			</screen>"""
	else:
		skin = """
			<screen name="LyricsView" position="0,0" size="720,576" flags="wfNoBorder" title="Merlin MP3 Player Lyrics" backgroundColor="#00000000">
				<widget name="lyric_text" position="149,84" size="417,414" font="Regular;22" zPosition="1" transparent="0"  backgroundColor="#00000000" />
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/Selektion-fs8.png" position="0,0" size="720,576" alphatest="on" zPosition="0"/>
			</screen>"""

	def __init__(self, session, text, currentTitle):
		self.session = session
		Screen.__init__(self, session)
		self["lyric_text"] = ScrollLabel()
		self.lyric = text
		self.currentTitle = currentTitle
		self.onLayoutFinish.append(self.startRun)
		self.onShown.append(self.lcdupdate)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EventViewActions"],
		{
			"back": self.close,
			"pageUp": self.pageUp,
			"pageDown": self.pageDown,
		}, -1)

	def startRun(self):
		self["lyric_text"].setText(self.lyric)

	def lcdupdate(self):
		self.summaries.setText("Lyrics",3)
		self.summaries.setText(self.currentTitle,1)

	def pageUp(self):
		self["lyric_text"].pageUp()

	def pageDown(self):
		self["lyric_text"].pageDown()

	def createSummary(self):
		return LCDScreen

class ScreenSaver(Screen):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="ScreenSaver" position="0,0" size="1280,720" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="coverArt" zPosition="2" position="100,77" size="300,300" transparent="1" alphatest="blend" />
				<widget name="display" position="100,382" zPosition="1" size="1028,30" font="Regular;26" valign="left" transparent="1" foregroundColor="#005B00" />
			</screen>"""
	else:
		skin = """
			<screen name="ScreenSaver" position="0,0" size="720,576" flags="wfNoBorder" backgroundColor="#00000000">
				<widget name="coverArt" zPosition="2" position="100,77" size="238,238" transparent="1" alphatest="blend" />
				<widget name="display" position="100,320" zPosition="1" size="439,28" font="Regular;24" valign="left" transparent="1" foregroundColor="#005B00" />
			</screen>"""
	
	def __init__(self, session, filename, text, currentTitle, nextTitle):
		self.session = session
		Screen.__init__(self, session)
		self["display"] = Label(text)
		self["coverArt"] = MerlinMP3PlayerPixmap()
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EventViewActions", "merlinActions"],
		{
			"back": self.close,
			"right": self.close,
			"left": self.close,
			"up": self.close,
			"down": self.close,
			"ok": self.close,
			"pageUp": self.close,
			"pageDown": self.close,
			"yellow": self.close,
			"blue": self.close,
			"red": self.close,
			"green": self.close,
			"right": self.close,
			"left": self.close,
			"prevBouquet": self.close,
			"nextBouquet": self.close,
			"info": self.close,
			"previous8k": self.close,
			"next8k": self.close,
			"pause": self.close,
			"stop": self.close,

		}, -1)
		merlin_mp3.CoverChanged().append(self.CoverChanged)
		merlin_mp3.TitleChanged().append(self.TitleChanged)
		merlin_mp3.ArtistChanged().append(self.ArtistChanged)
		merlin_mp3.CurrentChanged().append(self.CurrentChanged)
		merlin_mp3.NextTitleChanged().append(self.NextTitleChanged)
		self.currentcover = filename
		self.title = ""
		self.onClose.append(self.__onClose)
		self.onLayoutFinish.append(self.startRun)
		self.onShown.append(self.CoverInit)
		self.moveTimer = eTimer()
		self.moveTimer.timeout.get().append(self.moveTimer_Timeout)
		self.nextTitle = nextTitle
		self.currentTitle = currentTitle

		self.__event_tracker = ServiceEventTracker(screen=self, eventmap=
			{
				iPlayableService.evUpdatedInfo: self.__evUpdatedInfo,
				iPlayableService.evUser+13: self.__coverartchanged,
				iPlayableService.evEOF: self.__evEOF
			})


	def __evEOF(self):
		self["display"].setText("")

	def __coverartchanged(self):
		self["coverArt"].updateCoverArt("/tmp/.id3coverart")

	def __evUpdatedInfo(self):
		currPlay = self.session.nav.getCurrentService()
		if currPlay is not None:
			sTitle = currPlay.info().getInfoString(iServiceInformation.sTagTitle)
			sArtist = currPlay.info().getInfoString(iServiceInformation.sTagArtist)
			if (len(sArtist) != 0):
				sTitle = sTitle + "- " + sArtist
			self["display"].setText(sTitle)
			self.summaries.setText(sTitle,1)
			self.summaries.setText(merlin_mp3.ShowNext(),4)

	def startRun(self):
		self["coverArt"].onShow()

	def moveTimer_Timeout(self):
		if HDSkin:
			x = random.randint(0, 980)
			y = random.randint(0, 420)
			self["display"].move(ePoint(x,y+305))
		else:
			x = random.randint(0, 482)
			y = random.randint(0, 338)
			self["display"].move(ePoint(x,y+243))
		self["coverArt"].move(ePoint(x,y))
		

	def ArtistChanged(self,msg):
		if len(self.title) != 0:
			self["display"].setText(self.title + " - " + msg)
		else:
			self["display"].setText(msg)

	def TitleChanged(self,msg):
		self.title = msg
		self.summaries.setText(msg,1)

	def CoverInit(self):
		self.CoverChanged(self.currentcover)
		self.summaries.setText(self.nextTitle,4)
		self.summaries.setText(self.currentTitle,1)
		self.moveTimer.start(5000)

	def CoverChanged(self,filename):
		if len(filename) != 0:
			self["coverArt"].updateCoverArt(filename)
		else:
			self["coverArt"].hide()

	def CurrentChanged(self, msg):
		self.summaries.setText(msg,3)

	def NextTitleChanged(self,title, artist):
		if (len(artist) != 0):	
			text = title + " - " + artist
		else:
			text = title
		self.summaries.setText(text,4)


	def __onClose(self):
		if self.moveTimer.isActive():
			self.moveTimer.stop()
		merlin_mp3.CoverChanged().remove(self.CoverChanged)
		merlin_mp3.TitleChanged().remove(self.TitleChanged)
		merlin_mp3.ArtistChanged().remove(self.ArtistChanged)
		merlin_mp3.CurrentChanged().remove(self.CurrentChanged)
		merlin_mp3.NextTitleChanged().remove(self.NextTitleChanged)

	def createSummary(self):
		return LCDPlayerScreen

class CurrentPlayList(MenuList):
	def __init__(self, list, enableWrapAround = True):
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 18))
		self.l.setFont(1, gFont("Regular", 18))
	def postWidgetCreate(self, instance):
		MenuList.postWidgetCreate(self, instance)
		instance.setItemHeight(20)

	def buildList(self,listnew):
		self.list=[]
		width = self.l.getItemSize().width()
		for items in listnew:
			res = [ items ]
			res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, items[1]))
			self.list.append(res)
		self.l.setList(self.list)
		self.moveToIndex(merlin_mp3.GetCurrentIndex())

class iDreamList(MenuList):
	def __init__(self, list, enableWrapAround = True):
		MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
		self.l.setFont(0, gFont("Regular", 18))
		self.l.setFont(1, gFont("Regular", 18))
	def postWidgetCreate(self, instance):
		MenuList.postWidgetCreate(self, instance)
		instance.setItemHeight(20)

	def getCurrentIndex(self):
		return self.instance.getCurrentIndex()
		
	def moveSelectionTo(self,index):
		self.moveToIndex(index)

	def buildList(self,listnew):
		self.list=[]
		width = self.l.getItemSize().width()
		moveIndex = 0
		for items in listnew:
			res = [ items ]
			if (items[0] != "[Back]" and items[4] != 1):
				res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, ("%s (%s)" % (items[0], items[3]))))
			else:
				if ( items[4] == 1):
					res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_LEFT, items[0]))
				else:
					res.append((eListboxPythonMultiContent.TYPE_TEXT, 0, 0, width, 20, 0, RT_HALIGN_CENTER, items[0]))
			
			self.list.append(res)
		self.l.setList(self.list)
		self.moveToIndex(0)
class LCDScreen(Screen):
	skin = """
	<screen position="0,0" size="132,64" title="Merlin MP3 Player">
		<widget name="text3" position="4,0" size="132,14" font="Regular;10"/>
		<widget name="text1" position="4,14" size="132,35" font="Regular;16"/>
		<widget name="text4" position="4,49" size="132,14" font="Regular;10"/>
	</screen>"""

	def __init__(self, session, parent):
		Screen.__init__(self, session)
		self["text1"] = Label("Merlin MP3 Player")
		self["text3"] = Label("")
		self["text4"] = Label("")

	def setText(self, text, line):
		textleer = "    "
		text = text + textleer*10
		if line == 1:
			self["text1"].setText(text)
		elif line == 3:
			self["text3"].setText(text)
		elif line == 4:
			self["text4"].setText(text)

class LCDPlayerScreen(Screen):
	skin = """
	<screen position="0,0" size="132,64" title="Merlin MP3 Player">
		<widget name="text3" position="4,0" size="132,12" halign="center" valign="top" font="Regular;10"/>
		<widget name="text1" position="4,14" size="132,35" halign="center" valign="top" font="Regular;16"/>
		<widget name="text4" position="4,51" size="132,12" halign="center" valign="top" font="Regular;10"/>
	</screen>"""

	def __init__(self, session, parent):
		Screen.__init__(self, session)
		self["text1"] = Label("Merlin MP3 Player")
		self["text3"] = Label("")
		self["text4"] = Label("")

	def setText(self, text, line):
		if len(text) > 10:
			if (text[-4:] == ".mp3" or text[-4:] == ".MP3"):
				text = text[:-4]
		if line == 1:
			self["text1"].setText(text)
		elif line == 3:
			self["text3"].setText(text)
		elif line == 4:
			self["text4"].setText(text)

class MerlinMusicPlayer(Screen, InfoBarSeek):
	global HDSkin
	if HDSkin:
		skin = """
			<screen name="MerlinMusicPlayer" position="0,0" size="1280,720" title="Merlin Music Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/1280_720-fs8.png" position="0,0" size="1280,720" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="300,204" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="154,490" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="152,536" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="150,578" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="148,623" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="1117,651" size="36,29" alphatest="on"/>
				<widget source="session.CurrentService" render="Label" position="858,317" zPosition="1" size="88,25" font="Regular;21" halign="right" transparent="1" foregroundColor="#B7B7B7" >
					<convert type="ServicePosition">Position</convert>
				</widget>
				<widget name="Title" position="200,495" zPosition="1" size="1028,30" font="Regular;26" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="200,542" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="200,587" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="200,631" zPosition="1" size="1028,25" font="Regular;21" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="1151,655" zPosition="2" size="85,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="153,677" zPosition="2" size="1083,20" font="Regular;16" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="820,293" zPosition="1" size="198,14" pointer="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png:198,0" seek_pointer="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png:198,0" transparent="1" />
				<widget name="coverArt" zPosition="2" position="167,90" size="399,361" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/shuffle-fs8.png" zPosition="2" position="631,292" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/repeat-fs8.png" zPosition="2" position="629,261" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/play-fs8.png" zPosition="2" position="906,256" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/pause-fs8.png" zPosition="2" position="908,256" size="29,28" transparent="1" alphatest="blend"/>
			</screen>"""
	else:
		skin = """
			<screen name="MerlinMusicPlayer" position="0,0" size="720,576" title="Merlin Music Player" flags="wfNoBorder">
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/720_576-fs8.png" position="0,0" size="720,576" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nocover-fs8.png" position="156,130" size="128,128" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/title-fs8.png" position="94,357" size="29,39" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/album-fs8.png" position="90,403" size="36,35" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/artist-fs8.png" position="87,443" size="49,36" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/genre-fs8.png" position="88,483" size="35,37" alphatest="on"/>
				<ePixmap pixmap="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/nextsong-fs8.png" position="589,514" size="36,29" alphatest="on"/>
				<widget source="session.CurrentService" render="Label" position="510,218" zPosition="1" size="68,20" font="Regular;16" halign="right" transparent="1" foregroundColor="#B7B7B7" >
					<convert type="ServicePosition">Position</convert>
				</widget>
				<widget name="Title" position="134,363" zPosition="1" size="439,28" font="Regular;24" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#047BBC" />
				<widget name="Album" position="134,410" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Artist" position="134,450" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Genre" position="134,490" zPosition="1" size="439,22" font="Regular;16" valign="left" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitleCaption" position="622,519" zPosition="2" size="65,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="NextTitle" position="77,542" zPosition="2" size="610,16" font="Regular;12" halign="right" transparent="0" backgroundColor="#003366" foregroundColor="#999999" />
				<widget name="Progressbar" position="436,197" zPosition="1" size="198,14" pointer="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png:198,0" seek_pointer="/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/progressbar-fs8.png:198,0" transparent="1" />
				<widget name="coverArt" zPosition="2" position="100,77" size="238,238" transparent="1" alphatest="blend" />
				<widget name="shuffleArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/shuffle-fs8.png" zPosition="2" position="370,203" size="53,32" transparent="1" alphatest="blend"/>
				<widget name="repeatArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/repeat-fs8.png" zPosition="2" position="370,167" size="53,34" transparent="1" alphatest="blend"/>
				<widget name="playArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/play-fs8.png" zPosition="2" position="524,162" size="30,30" transparent="1" alphatest="blend"/>
				<widget name="pauseArt" pixmap = "/usr/lib/enigma2/python/Plugins/Extensions/MerlinMP3Player/skin/pause-fs8.png" zPosition="2" position="526,162" size="29,28" transparent="1" alphatest="blend"/>
			</screen>"""
		
	def __init__(self, session, directory, filename, level, id, subtable_id):
		self.session = session
		Screen.__init__(self, session)
		self["Title"] = Label()
		self["Album"] = Label()
		self["Artist"] = Label()
		self["Genre"] = Label()
		self["shuffleArt"] = MerlinMP3PlayerIcons()
		self["repeatArt"] = MerlinMP3PlayerIcons()
		self["playArt"] = MerlinMP3PlayerIcons()
		self["pauseArt"] = MerlinMP3PlayerIcons()
		self["NextTitleCaption"] = Label(_("Next Song"))
		self["NextTitle"] = Label()
		self["Progressbar"] = ServicePositionGauge(self.session.nav)
		self["coverArt"] = MerlinMP3PlayerPixmap()
		self.ScreenSaverTimer = eTimer()
		self.ScreenSaverTimer.timeout.get().append(self.ScreenSaverTimer_Timeout)
		self["actions"] = ActionMap(["WizardActions", "DirectionActions", "ColorActions", "EPGSelectActions", "MediaPlayerActions", "merlinActions"],
		{
			"back": self.close,
			"right": self.next,
			"left": self.previous,
			"up": self.getcurrentplaylist,
			"down": self.getcurrentplaylist,
			"prevBouquet": self.shufflelist,
			"nextBouquet": self.repeattitle,
			"info": self.getLyrics,
			"pause": self.pauseEntry, # 8k
			"stop": self.close, # 8k
		}, -1)


		self.__event_tracker = ServiceEventTracker(screen=self, eventmap=
			{
				iPlayableService.evUpdatedInfo: self.__evUpdatedInfo,
				iPlayableService.evUser+10: self.__evAudioDecodeError,
				iPlayableService.evUser+12: self.__evPluginError,
				iPlayableService.evUser+13: self.__coverartchanged
			})

		InfoBarSeek.__init__(self, actionmap = "MediaPlayerSeekActions")


		merlin_mp3.RepeatTitleChanged().append(self.RepeatTitleChanged)
		merlin_mp3.NextTitleChanged().append(self.NextTitleChanged)
		merlin_mp3.ShuffleStateChanged().append(self.ShuffleStateChanged)
		merlin_mp3.LyricsChanged().append(self.LyricsChanged)
		merlin_mp3.CoverChanged().append(self.CoverChanged)


		self.repeatmode = 0
		self.directory = directory
		self.filename = filename
		self.level = level
		self.id = id
		self.subtable_id = subtable_id
		self.shuffle = 0
		self.repeat_title = 0
		self.lyrics = ""
		self.currentcover = ""
		self.init = 0
		self.screensaverconfig = int(config.plugins.merlinmp3player.screensaver.value)
		self.coverconfig = int(config.plugins.merlinmp3player.covers.value)
		self.sortingconfig = int(config.plugins.merlinmp3player.sorting.value)
		self.onClose.append(self.__onClose)
		self.onShown.append(self.IconInit)
		self.onLayoutFinish.append(self.startRun)
		self.session.nav.stopService()
		musicfile = merlin_mp3.Start(self.directory, self.filename,self.coverconfig, self.sortingconfig,0)		
		self.PlayRef(musicfile)
		self.covershown = False
		self.musicfilename = ""
		
	def IconInit(self):
		if (self.init == 0):
			self.init = 1
			self.summaries.setText(merlin_mp3.ShowNext(),4)
			self.ResetScreenSaverTimer()
	
	def startRun(self):
		self["coverArt"].hide()
		self["pauseArt"].hide()
		self["shuffleArt"].hide()
		self["repeatArt"].hide()


	def __evUpdatedInfo(self):
		currPlay = self.session.nav.getCurrentService()
		if currPlay is not None:
			sTitle = currPlay.info().getInfoString(iServiceInformation.sTagTitle)
			if (len(sTitle) !=0):
				self["Title"].setText(sTitle)
				self.summaries.setText(sTitle,1)
			self["Genre"].setText(currPlay.info().getInfoString(iServiceInformation.sTagGenre))
			sArtist = currPlay.info().getInfoString(iServiceInformation.sTagArtist)
			self["Artist"].setText(sArtist)
			sAlbum = currPlay.info().getInfoString(iServiceInformation.sTagAlbum)			
			sYear = currPlay.info().getInfoString(iServiceInformation.sTagDate)
			if (len(sYear) != 0):
				sAlbum = sAlbum + " (" + sYear + ")"
			self["Album"].setText(sAlbum)
			if not self.covershown and sArtist != "" and sAlbum != "":
				self.covershown = True
				merlin_mp3.GetCoverArt(self.musicfilename,int(config.plugins.merlinmp3player.covers.value), sArtist,sAlbum)
				

	def __evAudioDecodeError(self):
		self["playArt"].hide()
		currPlay = self.session.nav.getCurrentService()
		sAudioType = currPlay.info().getInfoString(iServiceInformation.sUser+10)
		print "[__evAudioDecodeError] audio-codec %s can't be decoded by hardware" % (sAudioType)
		self.session.open(MessageBox, _("This Dreambox can't decode %s streams!") % sAudioType, type = MessageBox.TYPE_INFO,timeout = 20 )

	def __evPluginError(self):
		self["playArt"].hide()
		currPlay = self.session.nav.getCurrentService()
		message = currPlay.info().getInfoString(iServiceInformation.sUser+12)
		print "[__evPluginError]" , message
		self.session.open(MessageBox, message, type = MessageBox.TYPE_INFO,timeout = 20 )

	def __coverartchanged(self):
		global coverArtFileName
		coverArtFileName = "/tmp/.id3coverart"
		self["coverArt"].updateCoverArt(coverArtFileName)
		self.covershown = True

	def pauseEntry(self):
		self.pauseService()

	def checkSkipShowHideLock(self):
		self.updatedSeekState()

	def doEofInternal(self, playing):
		self.PlayRef(merlin_mp3.PlayNext())

	def updatedSeekState(self):
		if self.seekstate == self.SEEK_STATE_PAUSE:
			self["playArt"].hide()
			self["pauseArt"].show()
		elif self.seekstate == self.SEEK_STATE_PLAY:
			self["pauseArt"].hide()
			self["playArt"].show()

	def ScreenSaverTimer_Timeout(self):
		if self.ScreenSaverTimer.isActive():
			self.ScreenSaverTimer.stop()
		_text = self["Title"].getText()
		text = ""
		if len(_text) != 0:
			text = _text + " - "
		text = text + self["Artist"].getText()
		nt = merlin_mp3.ShowNext()
		if self.covershown:
			picfile = coverArtFileName
		else:
			picfile = ""
		self.session.openWithCallback(self.ResetScreenSaverTimer, ScreenSaver, picfile, text, _text, nt )

	def ResetScreenSaverTimer(self):
		if self.screensaverconfig != 0:
			if self.ScreenSaverTimer.isActive():
				self.ScreenSaverTimer.stop()
			self.ScreenSaverTimer.start(self.screensaverconfig * 10000)

	def PlayRef(self, musicfile):
		self["coverArt"].hide()
		self.covershown = False
		global coverArtFileName
		coverArtFileName = ""
		if len(musicfile) != 0:
			if ( self.repeatmode == 1):
				self.session.nav.playService(None)
			self.musicfilename = musicfile
			sref = eServiceReference(4097, 0, musicfile)
			self.session.nav.playService(sref)
			self["Title"].setText( musicfile)
			nt = merlin_mp3.ShowNext()
			self.summaries.setText(musicfile,1)
			self.summaries.setText("",3) # keine Ahnung, wie ich die Zeit anzeigen lassen soll...
			self["NextTitle"].setText(nt)
			self.summaries.setText(nt,4)

	def next(self):
		self.PlayRef(merlin_mp3.PlayNext())
		self.ResetScreenSaverTimer()

	def previous(self):
		self.PlayRef(merlin_mp3.PlayPrevious())
		self.ResetScreenSaverTimer()

	def getcurrentplaylist(self):
		self.session.openWithCallback(self.PlayRef, CurrentPlaylist)
		self.ResetScreenSaverTimer()

	def NextTitleChanged(self,title, artist):
		if (len(artist) != 0):	
			text = title + " - " + artist
		else:
			text = title
		self["NextTitle"].setText(text)
		self.summaries.setText(text,4)
		
		
	def repeattitle(self):
		merlin_mp3.RepeatTitle()
		self.ResetScreenSaverTimer()
		
	def RepeatTitleChanged(self,msg):
		self.repeatmode = msg
		if (msg != 1):
			self["repeatArt"].hide()
		else:
			self["repeatArt"].show()

	def shufflelist(self):
		merlin_mp3.ShuffleList()
		self.ResetScreenSaverTimer()
		
	def ShuffleStateChanged(self,msg):
		if (msg != 1):
			self["shuffleArt"].hide()
		else:
			self["shuffleArt"].show()

	def getLyrics(self):
		merlin_mp3.GetLyrics();
		self.ResetScreenSaverTimer()

	def LyricsChanged(self, msg):
		self.ResetScreenSaverTimer()
		self.lyrics = msg
		_text = self["Title"].getText()
		self.session.open(LyricsView,msg, _text)

	def CoverChanged(self,filename):
		global coverArtFileName
		if len(filename) != 0:
			self["coverArt"].updateCoverArt(filename)
			coverArtFileName = filename
		else:
			self["coverArt"].hide()
			coverArtFileName = ""

	def createSummary(self):
		return LCDPlayerScreen

	def __onClose(self):
		merlin_mp3.RepeatTitleChanged().remove(self.RepeatTitleChanged)
		merlin_mp3.NextTitleChanged().remove(self.NextTitleChanged)
		merlin_mp3.ShuffleStateChanged().remove(self.ShuffleStateChanged)
		merlin_mp3.LyricsChanged().remove(self.LyricsChanged)
		merlin_mp3.CoverChanged().remove(self.CoverChanged)

